# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['ZeroSync_Lucas',
 'ZeroSync_Lucas.chain_proof',
 'ZeroSync_Lucas.utils',
 'ZeroSync_Lucas.utreexo']

package_data = \
{'': ['*'],
 'ZeroSync_Lucas': ['block/*',
                    'block/utxo_dummies/*',
                    'crypto/*',
                    'serialize/*',
                    'stark_verifier/*',
                    'stark_verifier/air/*',
                    'stark_verifier/air/proof/*',
                    'stark_verifier/air/transitions/*',
                    'stark_verifier/crypto/*',
                    'stark_verifier/fri/*',
                    'stark_verifier/parser/*',
                    'stark_verifier/parser/src/*',
                    'transaction/*',
                    'utxo_set/*']}

setup_kwargs = {
    'name': 'zerosync-lucas',
    'version': '0.1.2',
    'description': '',
    'long_description': '<div align="center">\n  <h1>ZeroSync</h1>\n  <br />\n  <a href="#about"><strong>«A STARK proof to sync a Bitcoin full node in an instant»</strong></a>\n  <br />\n  <br />\n  <a href="https://github.com/ZeroSync/ZeroSync/issues/new?assignees=&labels=bug&template=01_BUG_REPORT.md&title=bug%3A+">Report a Bug</a>\n  |\n  <a href="https://github.com/ZeroSync/ZeroSync/issues/new?assignees=&labels=enhancement&template=02_FEATURE_REQUEST.md&title=feat%3A+">Request a Feature</a>\n  | <a href="https://github.com/ZeroSync/ZeroSync/discussions">Ask a Question</a>\n</div>\n\n<div align="center">\n<br />\n\n![GitHub Workflow Status](https://github.com/ZeroSync/ZeroSync/actions/workflows/CI.yml/badge.svg)\n[![Project license](https://img.shields.io/github/license/ZeroSync/ZeroSync.svg)](../LICENSE)\n[![Pull Requests welcome](https://img.shields.io/badge/PRs-welcome-ff69b4.svg?)](https://github.com/ZeroSync/ZeroSync/issues?q=is%3Aissue+is%3Aopen+label%3A%22help+wanted%22)\n![GitHub Repo stars](https://img.shields.io/github/stars/ZeroSync/ZeroSync?style=social)\n[![Twitter Follow](https://img.shields.io/twitter/follow/ZeroSync_?style=social)](https://twitter.com/ZeroSync_)\n\n</div>\n\n\n**Don\'t trust. Verify.** ZeroSync allows to verify Bitcoin\'s chain state in an instant. No need to download hundreds of gigabytes of blocks. A compact cryptographic proof suffices to validate the entire history of transactions and everyone\'s current balances. \n\nOur first application is to zerosync Bitcoin Core in pruned mode. The long-term vision for ZeroSync is to become a tool box for custom Bitcoin proofs. STARK proofs enable you to transform the blockchain data, enhance it, filter it, index it for efficient queries, and optimise it for your individual use case.\n\nThis is an early stage project. Expect frequent breaking changes. [Here is the project roadmap](roadmap.md).\n\nWARNING: THIS CODE IS STILL FULL OF CRITICAL SECURITY BUGS!\n\n## Requirements\n- Python 3.9\n- Cairo. [Installation Guide](https://www.cairo-lang.org/docs/quickstart.html) (Programming language for provable programs)\n- [Protostar](https://docs.swmansion.com/protostar/docs/tutorials/installation) (Automated testing)\n- [Giza](https://github.com/maxgillett/giza) (Required for prover. Not necessary for development and testing)\n\n\n## Run the Utreexo Bridge Node\nThe Utreexo bridge node is required to pass the tests for block verification. It provides the inclusion proofs for the coins spent in a block.\n\n```sh\nsource ~/cairo_venv/bin/activate\npython src/utreexo/bridge_node.py\n```\n\n\n## Run all Unit Tests\n```sh\nprotostar test --cairo-path=./src target src\n```\n\n## Build Parser\n```sh\ncd src/stark_verifier/parser/\ncargo +nightly build\n\ncd ../../..\n```\n\n## Run all Integration Tests\n```sh\nprotostar test --cairo-path=./src tests\n```\n\nRun some tests with the Rust verifier to derive a detailed ground truth:\n\n```sh\ncargo +nightly test -- --show-output\n```\n\n\n## Run the Chain Prover\n```sh\nsource ~/cairo_venv/bin/activate\npython3 src/chain_proof/main.py\n```\n\n\n## List TODOs\n```sh\n ./docs/todos\n```\n\n\n## Roadmap\n\nThe roadmap is available [here](roadmap.md).\n',
    'author': 'Your Name',
    'author_email': 'you@example.com',
    'maintainer': 'None',
    'maintainer_email': 'None',
    'url': 'None',
    'packages': packages,
    'package_data': package_data,
    'python_requires': '>=3.9,<4.0',
}


setup(**setup_kwargs)
